#ifndef stage_h
#define stage_h

#include <string>
#include "state.h"
#include "variant.h"


class Stage {
	////////////////////
	// Xe[g

	// Xe[W\t@C̓ǂݍ
	class State_LoadingStageConstructFile : public State<Stage> {
		std::string fileName;
	public:
		State_LoadingStageConstructFile(const char* stageFileName) : fileName(stageFileName) {}
		virtual StateInfo run(Stage *parent, State<Stage>* &newState);
	};

	// t@CI[vG[
	class State_OpenError : public State<Stage> {
		virtual StateInfo run(Stage *parent, State<Stage>* &newState);
	};

	// Xe[W\[X쐬
	class State_ConstructStage : public State<Stage> {
		std::vector<Variants> ary;
	public:
		State_ConstructStage(std::vector<Variants> ary) : ary(ary) {}
		virtual StateInfo run(Stage *parent, State<Stage>* &newState);
	};

	// tF[h
	class State_FadeIn : public State<Stage> {
		unsigned char curVal;
	public:
		State_FadeIn() : curVal(0xff) {}
		virtual StateInfo run(Stage *parent, State<Stage>* &newState);
	};

	// Q[Jn}
	class State_StartGame : public State<Stage> {
		ID3DXFont *font;
		int brink, counter;
		bool bBrink;
	public:
		State_StartGame(IDirect3DDevice9 *dev);
		State_StartGame();
		virtual StateInfo run(Stage *parent, State<Stage>* &newState);
		virtual void draw(Stage *parent);
	};

	// Q[
	class State_Gaming : public State<Stage> {
	public:
		virtual StateInfo run(Stage *parent, State<Stage>* &newState);
	};

	// ACh
	class State_Idle : public State<Stage> {
	public:
		virtual StateInfo run(Stage *parent, State<Stage>* &newState);
	};


	/////////////////////
	// ̑

	// \
	struct ObjectInfo {
		int x, y;
		ID3DXMesh *mesh;
		ObjectInfo(int x, int y, ID3DXMesh *mesh) : x(x), y(y), mesh(mesh) {}
		~ObjectInfo() {
			mesh->Release();
		}
		void draw(IDirect3DDevice9 *dev) {
			D3DMATERIAL9 mat = {{1.0f, 1.0f, 1.0f, 1.0f}};
			dev->SetMaterial(&mat);
			D3DXMATRIX m;
			D3DXMatrixTranslation(&m, (float)x, float(y), 0.0f);
			dev->SetTransform(D3DTS_WORLD, &m);
			mesh->DrawSubset(0);
		}
	};

	// tF[_[
	struct Fader {
		struct Vtx {
			float x, y, z, w;
			DWORD color;
		};
		Vtx vtx[4];
		unsigned char alpah;
		Fader() : alpah(0xff) {
			Vtx v[4] = {
				{  0.0f, 800.0f, 0.0f, 1.0f, 0xff000000},
				{  0.0f,   0.0f, 0.0f, 1.0f, 0xff000000},
				{800.0f, 800.0f, 0.0f, 1.0f, 0xff000000},
				{800.0f,   0.0f, 0.0f, 1.0f, 0xff000000},
			};
			memcpy(vtx, v, sizeof(v));
		}
		void trans(unsigned char a) {
			alpah = a;
			for (unsigned i = 0; i < 4; i++)
				vtx[i].color = a << 24 | 0x000000;
		}
		void draw(IDirect3DDevice9 *dev) {
			if (alpah != 0) {
				dev->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
				dev->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
				dev->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
				dev->SetFVF(D3DFVF_XYZRHW | D3DFVF_DIFFUSE);
				dev->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, vtx, sizeof(Vtx));
			}
		}
	};

	IDirect3DDevice9 *dev;
	State<Stage> *curState;
	std::vector<ObjectInfo*> objects;
	Fader fader;
	std::string stageName;

public:
	Stage(IDirect3DDevice9* dev, const char* stageFileName);
	~Stage();

	// XV
	void update();

	// `
	void draw();
};

#endif
